import { BootstrapModal } from './../index';
import { BootstrapModalBackdrop, BootstrapModalStyleMode } from './../index';
import { AfterViewInit, ElementRef, OnInit, OnChanges, OnDestroy, SimpleChanges, EventEmitter } from '@angular/core';
import { BaseElement } from './smart.element';
import * as i0 from "@angular/core";
export { BootstrapModalBackdrop, BootstrapModalStyleMode, ElementRenderMode } from './../index';
export { Smart } from './smart.element';
export { BootstrapModal } from './../index';
export declare class BootstrapModalComponent extends BaseElement implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    constructor(ref: ElementRef<BootstrapModal>);
    private eventHandlers;
    nativeElement: BootstrapModal;
    /** @description Creates the component on demand.
     * @param properties An optional object of properties, which will be added to the template binded ones.
     */
    createComponent(properties?: {}): any;
    /** @description Clicking on the modal “backdrop” will automatically close the modal.  */
    get backdrop(): BootstrapModalBackdrop | string;
    set backdrop(value: BootstrapModalBackdrop | string);
    /** @description Sets or gets whether the modal is centered.  */
    get centered(): boolean;
    set centered(value: boolean);
    /** @description Enables or disables the element.  */
    get disabled(): boolean;
    set disabled(value: boolean);
    /** @description Gets or sets whether the modal is opened.  */
    get opened(): boolean;
    set opened(value: boolean);
    /** @description Gets or sets whether the modal is scrollable.  */
    get scrollable(): boolean;
    set scrollable(value: boolean);
    /** @description Sets or gets the style mode of the element. */
    get styleMode(): BootstrapModalStyleMode | string;
    set styleMode(value: BootstrapModalStyleMode | string);
    /** @description Sets or gets the size mode of the element. */
    get sizeMode(): string;
    set sizeMode(value: string);
    /** @description Show event is triggered when the modal is going to show.
    *  @param event. The custom event. 	*/
    onShow: EventEmitter<CustomEvent>;
    /** @description Hide event is triggered when the modal is going to be hidden.
    *  @param event. The custom event. 	*/
    onHide: EventEmitter<CustomEvent>;
    /** @description Toggles the modal visibility
    */
    toggle(): void;
    /** @description Shows the modal
    */
    show(): void;
    /** @description Hides the modal
    */
    hide(): void;
    get isRendered(): boolean;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    /** @description Add event listeners. */
    private listen;
    /** @description Remove event listeners. */
    private unlisten;
    static ɵfac: i0.ɵɵFactoryDeclaration<BootstrapModalComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BootstrapModalComponent, "bootstrap-modal, [bootstrap-modal]", ["bootstrap-modal"], { "backdrop": "backdrop"; "centered": "centered"; "disabled": "disabled"; "opened": "opened"; "scrollable": "scrollable"; "styleMode": "styleMode"; "sizeMode": "sizeMode"; }, { "onShow": "onShow"; "onHide": "onHide"; }, never>;
}
